Index: tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.LICENSE
===================================================================
--- tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.LICENSE	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.LICENSE	(revision 2421)
@@ -0,0 +1,16 @@
+VLCJ is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+VLCJ is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+ 
+Copyright 2009-2019 Caprica Software Limited.
+
+VLCJ makes use of JNA (https://jna.dev.java.net/). JNA is licensed under LGPL.
Index: tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.icons
===================================================================
--- tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.icons	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/README.icons	(revision 2421)
@@ -0,0 +1,11 @@
+The icons for the demo media player application came from here:
+
+http://www.fatcow.com/free-icons/
+
+The license is here:
+
+http://creativecommons.org/licenses/by/3.0/us/
+
+These icons seem to be basically new versions of the Silk icons:
+
+http://www.famfamfam.com/lab/icons/silk/
Index: tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/copyright
===================================================================
--- tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/copyright	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/vlcj-4.1.0/doc/copyright	(revision 2421)
@@ -0,0 +1,18 @@
+
+Copyright (c) 2009-2019, Caprica Software Limited.
+
+This file is part of VLCJ.
+
+VLCJ is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+VLCJ is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+
Index: tmp/org.txm.backtomedia.rcp/.classpath
===================================================================
--- tmp/org.txm.backtomedia.rcp/.classpath	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/.classpath	(revision 2421)
@@ -1,20 +1,16 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
-	<classpathentry exported="true" kind="lib"
-		path="vlcj-2.4.1/jna-3.5.2.jar" />
-	<classpathentry exported="true" kind="lib"
-		path="vlcj-2.4.1/platform-3.5.2.jar" />
-	<classpathentry exported="true" kind="lib"
-		path="vlcj-2.4.1/vlcj-2.4.1.jar" />
-	<classpathentry kind="lib" path="opal-0.9.5.2.jar" />
-	<classpathentry kind="con"
-		path="org.eclipse.jdt.launching.JRE_CONTAINER" />
-	<classpathentry kind="con"
-		path="org.eclipse.pde.core.requiredPlugins">
+	<classpathentry exported="true" kind="lib" path="opal-0.9.5.2.jar"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins">
 		<accessrules>
-			<accessrule kind="accessible" pattern="**" />
+			<accessrule kind="accessible" pattern="**"/>
 		</accessrules>
 	</classpathentry>
-	<classpathentry kind="src" path="src" />
-	<classpathentry kind="output" path="bin" />
-</classpath>
\ No newline at end of file
+	<classpathentry kind="src" path="src"/>
+	<classpathentry exported="true" kind="lib" path="vlcj-4.1.0/jna-5.2.0.jar"/>
+	<classpathentry exported="true" kind="lib" path="vlcj-4.1.0/jna-platform-5.2.0.jar"/>
+	<classpathentry exported="true" kind="lib" path="vlcj-4.1.0/vlcj-4.1.0.jar"/>
+	<classpathentry exported="true" kind="lib" path="vlcj-4.1.0/vlcj-natives-4.1.0.jar"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
Index: tmp/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF	(revision 2421)
@@ -1,12 +1,13 @@
 Manifest-Version: 1.0
-Export-Package: org.txm.backtomedia.commands.function,org.txm.backtome
- dia.editors.input,org.txm.backtomedia.editors.vlcplayer,org.txm.backt
- omedia.preferences
 Bundle-SymbolicName: org.txm.backtomedia.rcp;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Bundle-Name: %Bundle-Name
-Bundle-ClassPath: .,vlcj-2.4.1/jna-3.5.2.jar,vlcj-2.4.1/platform-3.5.2
- .jar,vlcj-2.4.1/vlcj-2.4.1.jar,opal-0.9.5.2.jar
+Bundle-ClassPath: .,
+ vlcj-4.1.0/jna-5.2.0.jar,
+ vlcj-4.1.0/platform-5.2.0.jar,
+ vlcj-4.1.0/vlcj-4.1.0.jar,
+ vlcj-4.1.0/vlcj-natives-4.1.0.jar,
+ opal-0.9.5.2.jar
 Require-Bundle: org.txm.core;bundle-version="0.7.0";visibility:=reexport,
  org.txm.rcp;bundle-version="0.8.0";visibility:=reexport,
  org.eclipse.core.runtime;visibility:=reexport,
@@ -18,4 +19,11 @@
 Bundle-ManifestVersion: 2
 Bundle-RequiredExecutionEnvironment: JavaSE-1.8
 Bundle-Vendor: %Bundle-Vendor
+Export-Package: org.txm.backtomedia.commands.function,
+ org.txm.backtomedia.editors.input,
+ org.txm.backtomedia.editors.vlcplayer,
+ org.txm.backtomedia.preferences,
+ uk.co.caprica.vlcj.factory.swt,
+ uk.co.caprica.vlcj.player.embedded.videosurface.swt,
+ vlcplayerrcp
 
Index: tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/player/embedded/videosurface/swt/CompositeVideoSurface.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/player/embedded/videosurface/swt/CompositeVideoSurface.java	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/player/embedded/videosurface/swt/CompositeVideoSurface.java	(revision 2421)
@@ -0,0 +1,52 @@
+/*
+ * This file is part of VLCJ.
+ *
+ * VLCJ is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * VLCJ is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Copyright 2009-2019 Caprica Software Limited.
+ */
+
+package uk.co.caprica.vlcj.player.embedded.videosurface.swt;
+
+import org.eclipse.swt.widgets.Composite;
+import uk.co.caprica.vlcj.player.base.MediaPlayer;
+import uk.co.caprica.vlcj.player.embedded.videosurface.VideoSurface;
+import uk.co.caprica.vlcj.player.embedded.videosurface.VideoSurfaceAdapter;
+
+/**
+ * Implementation of a video surface component that uses an SWT Composite.
+ */
+public class CompositeVideoSurface extends VideoSurface {
+	
+	/**
+	 *
+	 */
+	private final Composite composite;
+	
+	/**
+	 *
+	 *
+	 * @param composite
+	 * @param videoSurfaceAdapter
+	 */
+	public CompositeVideoSurface(Composite composite, VideoSurfaceAdapter videoSurfaceAdapter) {
+		super(videoSurfaceAdapter);
+		this.composite = composite;
+	}
+	
+	@Override
+	public void attach(MediaPlayer mediaPlayer) {
+		videoSurfaceAdapter.attach(mediaPlayer, composite.embeddedHandle);
+	}
+}

Index: tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtMediaPlayerFactory.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtMediaPlayerFactory.java	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtMediaPlayerFactory.java	(revision 2421)
@@ -0,0 +1,68 @@
+/*
+ * This file is part of VLCJ.
+ *
+ * VLCJ is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * VLCJ is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Copyright 2009-2019 Caprica Software Limited.
+ */
+
+package uk.co.caprica.vlcj.factory.swt;
+
+import uk.co.caprica.vlcj.factory.discovery.NativeDiscovery;
+import uk.co.caprica.vlcj.factory.MediaPlayerFactory;
+
+import java.util.Collection;
+
+// FIXME should we build an SwtEmbeddedMediaPlayerComponent that extends Composite, similar to how we extend JPanel for SWT?
+
+/**
+ * Extension to the default {@link MediaPlayerFactory} that provides SWT components.
+ */
+public class SwtMediaPlayerFactory extends MediaPlayerFactory {
+	
+	private final SwtApi swtApi;
+	
+	public SwtMediaPlayerFactory(NativeDiscovery discovery, String... libvlcArgs) {
+		super(discovery, libvlcArgs);
+		
+		this.swtApi = new SwtApi(this);
+	}
+	
+	public SwtMediaPlayerFactory(String... libvlcArgs) {
+		this(null, libvlcArgs);
+	}
+	
+	public SwtMediaPlayerFactory(NativeDiscovery discovery, Collection<String> libvlcArgs) {
+		this(discovery, libvlcArgs.toArray(new String[libvlcArgs.size()]));
+	}
+	
+	public SwtMediaPlayerFactory(Collection<String> libvlcArgs) {
+		this(null, libvlcArgs.toArray(new String[libvlcArgs.size()]));
+	}
+	
+	/**
+	 *
+	 *
+	 * @return
+	 */
+	public final SwtApi swt() {
+		return swtApi;
+	}
+	
+	@Override
+	public void onBeforeRelease() {
+		swtApi.release();
+	}
+	
+}

Index: tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/BaseApi.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/BaseApi.java	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/BaseApi.java	(revision 2421)
@@ -0,0 +1,32 @@
+/*
+ * This file is part of VLCJ.
+ *
+ * VLCJ is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * VLCJ is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Copyright 2009-2019 Caprica Software Limited.
+ */
+
+package uk.co.caprica.vlcj.factory.swt;
+
+abstract class BaseApi {
+	
+	protected final SwtMediaPlayerFactory factory;
+	
+	BaseApi(SwtMediaPlayerFactory factory) {
+		this.factory = factory;
+	}
+	
+	protected void release() {}
+	
+}

Index: tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtApi.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtApi.java	(revision 0)
+++ tmp/org.txm.backtomedia.rcp/src/uk/co/caprica/vlcj/factory/swt/SwtApi.java	(revision 2421)
@@ -0,0 +1,50 @@
+/*
+ * This file is part of VLCJ.
+ *
+ * VLCJ is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * VLCJ is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with VLCJ.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Copyright 2009-2019 Caprica Software Limited.
+ */
+
+package uk.co.caprica.vlcj.factory.swt;
+
+import org.eclipse.swt.widgets.Composite;
+import uk.co.caprica.vlcj.player.embedded.videosurface.VideoSurfaceAdapters;
+import uk.co.caprica.vlcj.player.embedded.videosurface.swt.CompositeVideoSurface;
+
+/**
+ *
+ */
+public final class SwtApi extends BaseApi {
+	
+	/**
+	 *
+	 *
+	 * @param mediaPlayerFactory
+	 */
+	public SwtApi(SwtMediaPlayerFactory mediaPlayerFactory) {
+		super(mediaPlayerFactory);
+	}
+	
+	/**
+	 *
+	 *
+	 * @param composite
+	 * @return
+	 */
+	public CompositeVideoSurface newCompositeVideoSurface(Composite composite) {
+		return new CompositeVideoSurface(composite, VideoSurfaceAdapters.getVideoSurfaceAdapter());
+	}
+	
+}

Index: tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/ApplicationActionBarAdvisor.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/ApplicationActionBarAdvisor.java	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/ApplicationActionBarAdvisor.java	(revision 2421)
@@ -6,15 +6,13 @@
 import org.eclipse.ui.application.IActionBarConfigurer;
 
 public class ApplicationActionBarAdvisor extends ActionBarAdvisor {
-
-    public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
-        super(configurer);
-    }
-
-    protected void makeActions(IWorkbenchWindow window) {
-    }
-
-    protected void fillMenuBar(IMenuManager menuBar) {
-    }
-    
+	
+	public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
+		super(configurer);
+	}
+	
+	protected void makeActions(IWorkbenchWindow window) {}
+	
+	protected void fillMenuBar(IMenuManager menuBar) {}
+	
 }
Index: tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/Application.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/Application.java	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/src/vlcplayerrcp/Application.java	(revision 2421)
@@ -12,8 +12,9 @@
 public class Application implements IApplication {
 	
 	public static String PLUGIN_ID = "org.txm.backtomedia"; //$NON-NLS-1$
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.equinox.app.IApplication#start(org.eclipse.equinox.app.IApplicationContext)
 	 */
 	public Object start(IApplicationContext context) throws Exception {
@@ -24,12 +25,14 @@
 				return IApplication.EXIT_RESTART;
 			else
 				return IApplication.EXIT_OK;
-		} finally {
+		}
+		finally {
 			display.dispose();
 		}
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.equinox.app.IApplication#stop()
 	 */
 	public void stop() {
@@ -38,6 +41,7 @@
 		final IWorkbench workbench = PlatformUI.getWorkbench();
 		final Display display = workbench.getDisplay();
 		display.syncExec(new Runnable() {
+			
 			public void run() {
 				if (!display.isDisposed())
 					workbench.close();
Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java	(revision 2421)
@@ -11,19 +11,19 @@
 public class VLCPlayerEditor extends EditorPart {
 	
 	/** The Constant ID. */
-	public static final String ID = VLCPlayerEditor.class.getCanonicalName(); //$NON-NLS-1$
+	public static final String ID = VLCPlayerEditor.class.getCanonicalName(); // $NON-NLS-1$
 	
 	VLCPlayer player;
-
+	
 	@Override
 	public void createPartControl(Composite parent) {
 		player = new VLCPlayer(parent, SWT.NONE);
 	}
-
+	
 	public void init() {
 		
 	}
-
+	
 	@Override
 	public void setFocus() {
 		
@@ -31,25 +31,32 @@
 	
 	@Override
 	public void dispose() {
-		try {if (player != null) player.stop();}
-		catch(Exception e) {e.printStackTrace();}
+		try {
+			if (player != null) player.stop();
+		}
+		catch (Exception e) {
+			e.printStackTrace();
+		}
 		
 		super.dispose();
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#doSave(org.eclipse.core.runtime.IProgressMonitor)
 	 */
 	@Override
-	public void doSave(IProgressMonitor monitor) { }
-
-	/* (non-Javadoc)
+	public void doSave(IProgressMonitor monitor) {}
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#doSaveAs()
 	 */
 	@Override
-	public void doSaveAs() { }
-
-	/* (non-Javadoc)
+	public void doSaveAs() {}
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#init(org.eclipse.ui.IEditorSite, org.eclipse.ui.IEditorInput)
 	 */
 	@Override
@@ -57,17 +64,18 @@
 			throws PartInitException {
 		setSite(site);
 		setInput(input);
-		//VLCPlayerEditorInput ii = (VLCPlayerEditorInput) input;
+		// VLCPlayerEditorInput ii = (VLCPlayerEditorInput) input;
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
 	public boolean isSaveAsAllowed() {
 		return false;
 	}
-
+	
 	public VLCPlayer getPlayer() {
 		return player;
 	}
@@ -75,17 +83,18 @@
 	public void setPartName(String partName) {
 		super.setPartName(partName);
 	}
-
+	
 	@Override
 	public boolean isDirty() {
 		return false;
 	}
-
+	
 	/**
 	 * for more test use "player.getEmbeddedMediaPlayer()"
+	 * 
 	 * @return false if the media could not be loaded (file not found, access error...)
 	 */
 	public boolean isMediaLoaded() {
-		return player.getEmbeddedMediaPlayer().isPlayable();
+		return player.getEmbeddedMediaPlayer().status().isPlayable();
 	}
-}
\ No newline at end of file
+}
